<template>
  <div class="text-right">
    <v-dialog v-model="dialog" persistent height="auto" width="1100">
      <template v-slot:activator="{ on, attrs }">
        <v-btn
          class="
            button-text
            v-btn v-btn--outlined v-btn--rounded
            theme--light
            v-size--default
            tway-violet--text
          "
          color="coral lighten-2"
          outlined
          v-bind="attrs"
          v-on="on"
        >
          <v-icon
            color="deep-orange accent-4

"
          >
            mdi-chart-areaspline
          </v-icon>

          Seguimiento
        </v-btn>
      </template>

      <v-card :class="'modalSystem'">
        <v-card>
          <div class="container">
            <v-btn icon right @click="dialog = false" class="float-right">
              <v-icon>mdi-close</v-icon>
            </v-btn>
            <h3 class="text-center">SEGUIMIENTO PRESUPUESTO</h3>
            <h4 class="text-center font-weight-regular">
              Ingresa nuevo Seguimiento
            </h4>
            <v-simple-table class="table mt-5" fixed-header>
              <template>
                <thead>
                  <tr>
                    <th class="text-center" width="5%" scope="col">ID</th>
                    <th class="text-center" width="15%" scope="col">Año</th>
                    <th class="text-center" width="15%" scope="col">Mes</th>
                    <th class="text-center" width="20%" scope="col">
                      Centro Costo
                    </th>
                    <th class="text-center" width="15%" scope="col">Ítem</th>
                    <th class="text-center" width="15%" scope="col">Monto</th>
                    <th class="text-center" scope="col">Acciones</th>
                  </tr>
                </thead>
                <tbody>
                  <tr
                    :v-if="items.length > 0"
                    v-for="(item, index) in items"
                    :key="index"
                    :class="item.isVisible ? activeClass : hidden"
                    class="edit_row"
                  >
                    <td class="text-center">{{ index + 1 }}</td>
                    <td class="text-center">
                      <v-select
                        :items="anios"
                        label="Año"
                        v-model="item.anio"
                        outlined
                      ></v-select>
                    </td>
                    <td class="text-center">
                      <v-select
                        :items="meses"
                        label="Mes"
                        v-model="item.mes"
                        outlined
                      ></v-select>
                    </td>
                    <td class="text-center">
                      <v-select
                        :items="costos"
                        label="Unidad de Costo"
                        v-model="item.costo"
                        outlined
                      ></v-select>
                    </td>
                    <td class="text-center">
                      <v-text-field
                        v-model="item.total"
                        label="Ítem"
                        maxlength="15"
                        minlenght="0"
                        :counter="15"
                        outlined
                      ></v-text-field>
                    </td>
                    <td class="text-center">
                      <span class="peso">$</span>
                      <v-text-field
                        v-model="item.monto"
                        label="Monto"
                        type="number"
                        maxlength="15"
                        minlenght="0"
                        :counter="15"
                        outlined
                      ></v-text-field>
                    </td>
                    <td class="text-center buttons">
                      <v-tooltip right>
                        <template v-slot:activator="{ on, attrs }">
                          <v-btn
                            icon
                            color="primary"
                            class="edit"
                            @click="saveItem(item)"
                            v-bind="attrs"
                            v-on="on"
                          >
                            <v-icon>edit</v-icon>
                          </v-btn>
                        </template>
                        <span>Editar</span>
                      </v-tooltip>
                      <v-tooltip right>
                        <template v-slot:activator="{ on, attrs }">
                          <v-btn
                            icon
                            color="primary"
                            class="save"
                            @click="saveItem(item)"
                            v-bind="attrs"
                            v-on="on"
                          >
                            <v-icon>save</v-icon>
                          </v-btn>
                        </template>
                        <span>Guardar</span>
                      </v-tooltip>
                      <v-tooltip right>
                        <template v-slot:activator="{ on, attrs }">
                          <v-btn
                            icon
                            color="error"
                            v-bind="attrs"
                            v-on="on"
                            @click="removeItem()"
                          >
                            <v-icon>delete</v-icon>
                          </v-btn>
                        </template>
                        <span>Eliminar</span>
                      </v-tooltip>
                    </td>
                  </tr>
                </tbody>
              </template>
            </v-simple-table>
            <v-row>
              <v-col md="12" class="justify-center">
                <div class="btn d-flex justify-center mt-6">
                  <v-btn
                    class="
                      button-text
                      v-btn v-btn--outlined v-btn--rounded
                      theme--light
                      v-size--default
                      tway-violet--text
                      justify-center
                    "
                    outlined
                    color="indigo lighten-2"
                    @click="AddItem()"
                  >
                    <v-icon color="purple"> mdi-plus </v-icon>
                    Agregar otro
                  </v-btn>
                </div>
              </v-col>
            </v-row>
          </div>
        </v-card>
      </v-card>
    </v-dialog>
  </div>
</template>

<script>
export default {
  data() {
    return {
      dialog: false,
      anios: ["2019", "2020", "2021", "2022"],
      meses: [
        "Enero",
        "Febrero",
        "Marzo",
        "Abril",
        "Mayo",
        "Junio",
        "Julio",
        "Agosto",
        "Septiembre",
        "Octubre",
        "Noviembre",
        "Diciembre",
      ],
      costos: ["Dolares", "Pesos", "Euros", "Libras"],
      items: [
        {
          anio: "",
          mes: "",
          costo: "",
          total: "",
          monto: "",
        },
      ],
      nameRules: [
        (v) => !!v || "Requerido.",
        (v) => v.length <= 15 || "Máximo 15 carácteres.",
      ],
      isVisible: true,
      activeClass: "is-visible",
    };
  },
  methods: {
    AddItem() {
      this.items.push({
        anio: this.anio,
        mes: this.mes,
        costo: this.costo,
        total: this.total,
        monto: this.monto,
      });
    },
    removeItem() {
      if (this.items.length > 1) {
        this.items.splice(this.items, 1);
      }
    },
    saveItem(item) {
      item.isVisible = !item.isVisible;
      this.$forceUpdate();
    },
  },
};
</script>

<style>
.shrink {
  width: 150px;
}
.bar {
  width: 350px;
}
.modalSystem {
  border-radius: 0px !important;
}
.v-menu__content.theme--light.v-menu__content--fixed.menuable__content__active {
  background-color: #fff;
}
.modalSystem .v-card.v-sheet.theme--light {
  padding: 20px 40px;
}
.modalSystem label.v-label.theme--light,
.edit_row .v-text-field__details {
  font-family: "Josefin Sans", sans-serif !important;
}
.modalSystem fieldset {
  border-color: #4a148c !important;
}
.modalSystem label.v-label--active {
  color: #4a148c !important;
}
.modalSystem button.v-btn.primary {
  background-color: #4a148c !important;
  border-color: #4a148c !important;
}
.edit_row .v-input__slot,
.edit_row .v-select {
  min-height: 35px !important;
  max-height: 35px !important;
  margin-bottom: 0px !important;
}
.edit_row .v-text-field--outlined .v-label {
  top: 8px;
  font-size: 13px !important;
}
.edit_row .v-input__append-inner {
  margin-top: 5px !important;
}
.edit_row .v-text-field__details {
  display: none;
}
.edit_row .v-select__selection,
.edit_row .v-text-field__slot input {
  font-size: 0.875rem;
}
.edit_row label.v-label.v-label--active.theme--light {
  top: 18px;
}
tr.edit_row td {
  height: 60px !important;
}
.modalSystem .edit_row fieldset {
  border-color: #fff !important;
  background-color: #f2f2f2;
}
.modalSystem .v-data-table__wrapper {
  max-height: 408px;
  overflow: auto;
}
.modalSystem .edit_row.is-visible fieldset {
  border-color: transparent !important;
  background-color: transparent;
}
.modalSystem button.float-right {
  z-index: 9;
  top: 15px;
  right: 15px;
  position: absolute;
}
.peso {
  float: left;
  margin-right: 5px;
  top: 7px;
  position: relative;
}
tr.edit_row td .edit {
  display: none;
}
tr.edit_row.is-visible td {
  pointer-events: none;
}
tr.edit_row.is-visible td.buttons {
  pointer-events: visible;
}
tr.edit_row.is-visible td .save {
  display: none !important;
}
tr.edit_row.is-visible td .edit {
  display: inline-grid !important;
}
tr.edit_row.is-visible .v-input__append-inner {
  display: none !important;
}
tr.edit_row.is-visible label.v-label.v-label--active.theme--light {
  display: none;
}
</style>
